import json
import os
import re

from app import app
from flask import Flask, request

# import ocs
import air

debug = False

oc = air.OneClass()

@app.route('/')
def root():
	return app.send_static_file('index.html')

@app.route('/list')
def _list():
	datalist = [name for name in os.listdir("app/data")]
	
	if ".DS_Store" in datalist:
		datalist.remove(".DS_Store")
		
	return json.dumps(datalist)

@app.route('/data/<dataname>')
def _data(dataname):
	# data preprocessing
	fpath = 'app/data/' + dataname + '/data.json'
	data = json.load(open(fpath, 'r'))
	return json.dumps(data)

@app.route('/data/start')
def start():
	quote_keys_regex = r'([\{\s,])(\w+)(:)'
	obj = request.args.get('input')
	# print obj
	obj = json.loads(re.sub(quote_keys_regex, r'\1"\2"\3', obj))
	id_list, fea_list = air.gridFeat(obj)
	cmap = oc.start(fea_list, id_list)

	return json.dumps(cmap)

@app.route('/data/update')
def update():
	gid = request.args.get('gid')
	res = request.args.get('res')
	
	gids = [int(x) for x in gid.split(',')]
	ress = [int(x) for x in res.split(',')]
	print gids

	cmap = oc.update(gids, ress);
	return json.dumps(cmap)
