# -*- coding: utf-8 -*-
"""
Created on Thu Jul 20 11:56:16 2017

@author: FH
"""

import random
import json
import numpy as np
from sklearn import svm, preprocessing
from gen_data_n import genFeats, mu, Sigma
from metric_learn import SDML_Supervised, NCA
import copy
from scipy import spatial 
from random import sample

n = 5
nca = NCA(max_iter=1000, learning_rate=0.01)




    

class OCS:
    num = 200 # number of features to generate
    sam_idx = sample(range(len(mu)), n)
    
    
    def __init__(self):
        self.train = []
        self.test = []
        self.mu = mu
        self.Sigma = Sigma
        self.anomaly = []
        self.param = []
        self.q = []
        self.M = np.identity(n)
        self.abnormal = []
        

    def start(self, task_id):
        self.train, self.abnormal = genFeats(self.mu, self.Sigma, self.num)
        self.train = map(lambda x: np.array(x)[self.sam_idx], self.train)
	self.abnormal = map(lambda x: np.array(x)[self.sam_idx], self.abnormal)
        #print len(self.train)

        def my_kernel(X, Y): 
            l = len(X)
            #print(X.shape)
            #print(X.shape)
            result = np.zeros([l,len(Y)])
            for i in range(l):
                for j in range(len(Y)):
                    result[i,j] = np.dot(np.dot((X[i]-Y[j]),self.M),(X[i]-Y[j]).T)
            gamma = 0.1 
            #result = np.exp(-gamma * np.dot((X-Y),(X-Y).T)).T
            #result = np.exp(-gamma * np.dot(np.dot((X-Y),M),(X-Y).T))
        #    nca = NCA(max_iter=1000, learning_rate=0.01)
        #    nca.fit(X, label)
        #    M = nca.metric()
            #result = []
            #for i in range(len(X)):
            #    result.append(np.exp(-gamma * np.dot(np.dot((X[i]-Y[i]),M),(X[i]-Y[i]).T)))
            result = np.exp(-gamma * result)
            return result
        
	self.test = []
	self.anomaly = []
	self.q = []
        with open('app/data/data.json') as f:
            data = json.load(f)
        self.param = data[task_id]['param']
        for g in data[task_id]['grids']:
            self.test.append(g['gridFeat'])
            self.q.append(g['q'])
            self.anomaly.append(sum(map(lambda x: x['isAnomaly'], g['dots'])))
        self.test = map(lambda x: np.array(x)[self.sam_idx], self.test)
        clf = svm.OneClassSVM(nu = 0.1, kernel=my_kernel, gamma = 0.1)
        clf.fit(self.train)
        colors = clf.decision_function(self.test).flatten().tolist()
        colors = map(lambda x: 0.1 if x>0 else -x, colors)
        mmscaler = preprocessing.MinMaxScaler()
        colors = mmscaler.fit_transform(colors).tolist()
        return colors
        
    def update(self, grid_id, response):        
        #for i in range(100-int(self.q[grid_id]*100)):
        self.label = list(np.zeros([1,len(self.train)])[0])+ list(np.ones([1,len(self.abnormal)])[0])
        train = copy.deepcopy(self.train+self.abnormal)
        if response == 1:
            train.append(self.test[grid_id])
            self.label.append(self.q[grid_id])
        else:
            train.append(self.test[grid_id])
            self.train.append(self.test[grid_id])
            self.label.append(0)
            
        self.label = np.array(self.label)
	sdml = SDML_Supervised(num_constraints=200)
        sdml.fit(np.array(train), self.label)
        self.M = sdml.metric()
        
        def my_kernel(X, Y): 
            l = len(X)
            result = np.zeros([l,len(Y)])
            for i in range(l):
                for j in range(len(Y)):
                    result[i,j] = np.dot(np.dot((X[i]-Y[j]),self.M),(X[i]-Y[j]).T)
            gamma = 0.1 
            result = np.exp(-gamma * result)
            return result
            
        clf = svm.OneClassSVM(kernel=my_kernel)
        clf.fit(self.train)
        colors = clf.decision_function(self.test).flatten().tolist()
        colors = map(lambda x: 0.1 if x>0 else -x, colors)
        mmscaler = preprocessing.MinMaxScaler()
        colors = mmscaler.fit_transform(colors).tolist()
        return colors

