vis.mapView = function() {
    var component = {},
        container = null,
        divisions = null,
        regions = null,
        map = {},
        data = {},
        dataname='newyork',
        map_sum={},
        cluster = {},
        Glyph={},
        RRadio={},
        Trip={},
        realID = {},
        size = [1024, 800],
        margin = { left: 10, top: 10, right: 10, bottom: 10 },
        dispatch = d3.dispatch("select", "mouseover", "mouseout", "load","select_trip","contextmenu"),
        mapping = {},
        glyph1_true=false,
        glyph2_true=false,
        glyph3_true=false,
        trip_id=-1,
        setfilter=0.4,
        setflows=[0,1];

    var day = 0,
        last = 0,
        next = 1,
        rate = 0,
        //color = ["#8dd3c7", "#ffffb3", "#bebada", "#fb8072", "#80b1d3", "#fdb462", "#b3de69", "#fccde5", "#d9d9d9", "#bc80bd"];
        color = ["#a6cee3", "#1f78b4", "#b2df8a", "#33a02c", "#fb9a99", "#e31a1c", "#fdbf6f", "#ff7f00", "#cab2d6", "#6a3d9a","#ffff99","#b15928","#8dd3c7","#fb8072","#fccde5","#d9d9d9"];
        //color = ["#a6cee3","#ff7f00","#b2df8a","#fb9a99","#33a02c","#1f78b4","#fdbf6f","#e31a1c","#cab2d6"];
    //     nrow = 22;
    var ncol = 24,
        nrow = 36;

    var color = d3.interpolateRgb(d3.rgb(103, 0, 31), d3.rgb(5, 48, 97));
    var max = 0;
    var min = 1;

    var seleGrids = {"1" : [], "2" : []};
    var selection = {"1" : [], "2" : []};
    var hover = true;

    mapboxgl.accessToken = 'pk.eyJ1IjoiY2hqemMiLCJhIjoiY2l5eWIyYzNmMDBrczJxcG9vNG50emEyMyJ9.1eSIGPqLOlrZQ60VRuHR1w';
    

    component.container = function(_) {
        if (!arguments.length) return container;
        container = _;
        size = [580, 580];

        map = new mapboxgl.Map({
            container: container,
            style: 'mapbox://styles/mapbox/light-v8',
            attributionControl: false,
            preserveDrawingBuffer: true
        });

        map.doubleClickZoom.disable();

        d3.selectAll(".mapboxgl-map canvas")
            .style("position", "relative")
            .style("z-index", 1)
        //     .style("width", "100%")
        //     .style("height", "100%");

        map.on('zoom', function(e) {
            component.layout().update();
        });

        map.on("drag", function(e) {
            component.layout().update();
        });

        map.on("rotate", function(e) {
            component.layout().update();
        });

        map.on("load", dispatch.load);

        return component;
    };

    component.on = function(event, func) {
        map.on(event, func);
    };

    component.coordinates = function(_) {
        if (!arguments.length) return latlng;
        latlng = _;
        return component;
    };

    component.dataname = function(_) {
        if (!arguments.length) return dataname;
        dataname = _;
        if(dataname=='newyork'){
            ncol = 28,
            nrow = 22;
        }else if(dataname=='manhattan'){
            ncol = 24;
            nrow = 36;
        }
        return component;
    };

    component.divisions = function(_) {
        if (!arguments.length) return divisions;
        divisions = _;
        return component;
    };

    component.regions = function(_) {
        if (!arguments.length) return regions;
        regions = _;

        regions.features.forEach( function(element, index) {
            // statements
            if (element.properties.totalCrashes && element.properties.totalCrashes > max) {
                max = element.properties.totalCrashes;
            }

            if (element.properties.totalCrashes && element.properties.totalCrashes < min) {
                min = element.properties.totalCrashes;
            }

            element.click = 0;
            element.selected = 0;
        });

        seleGrids = { "1": [], "2": []};
        selection = {"1" : [], "2" : []};
        return component;
    };

    component.map_sum = function(_){
        if (!arguments.length) return map_sum;
        map_sum = _;
        return component;
    };

    component.realID = function(_) {
        if (!arguments.length) return realID;
        realID = _;
        return component;
    };

    component.data = function(_) {
        if (!arguments.length) return data;
        data = _;
        return component;
    };

    component.Glyph=function(_){
        if(!arguments.length) return Glyph;
        Glyph=_;
        return component;
    };

    component.RRadio=function(_){
        if(!arguments.length) return RRadio;
        RRadio=_;
        return component;
    };

    component.Trip=function(_){
        if(!arguments.length) return Trip;
        Trip=_;
        return component;
    };


    component.glyph1_true=function(_){
        if(!arguments.length) return glyph1_true;
        glyph1_true=_;
        return component;
    };

    component.glyph2_true=function(_){
        if(!arguments.length) return glyph2_true;
        glyph2_true=_;
        return component;
    };

    component.glyph3_true=function(_){
        if(!arguments.length) return glyph3_true;
        glyph3_true=_;
        return component;
    };

    component.trip_id=function(_){
        if(!arguments.length) return trip_id;
        trip_id=_;
        return component;
    };

    component.setfilter=function(_){
        if(!arguments.length) return setfilter;
        setfilter=_;
        return component;
    };

    component.setflows=function(_){
        if(!arguments.length) return setflows;
        setflows=_;
        return component;
    };

    component.cluster = function(_) {
        if (!arguments.length) return cluster;
        cluster = _;
        return component;
    };

    component.timepoint = function(_) {
        if (!arguments.length) return timepoint;
        timepoint = _;
        return component;
    };


    component.size = function(_) {
        if (!arguments.length) return size;
        size = _;
        return component;
    };

    component.margin = function(_) {
        if (!arguments.length) return margin;
        margin = _;
        return component;
    };

    component.day = function(_) {
        if (!arguments.length) return day;
        day = _;
        return component;
    };

    component.style = function(_) {
        if (!map) {
            return;
        }

        if (!arguments.length) return map.getStyle();

        map.setStyle('mapbox://styles/mapbox/' + _ + '-v8');
        return component;
    };

    component.center = function(_) {
        if (!map) {
            return;
        }
        if (!arguments.length) return map.getCenter();
        map.setCenter(_);
        return component;
    };

    component.zoom = function(_) {
        if (!map) {
            return;
        }
        if (!arguments.length) return map.getZoom();
        map.setZoom(_);
        return component;
    };

    component.bearing = function(_) {
        if (!map) {
            return;
        }
        if (!arguments.length) return map.getBearing();
        map.setBearing(_);
        return component;
    };

    component.addControl = function(_) {

        if (!map) return;

        map.addControl(_);

        return component;
    };

    component.changed = function(d){
        if(d.rid){
            if(cluster[day].Cluster[d.rid]<cluster[day].LMP.length-1){
                cluster[day].Cluster[d.rid]=cluster[day].Cluster[d.rid]+1;
            }else{
                cluster[day].Cluster[d.rid]=0;
            }
        }
        component.layout().update();
    };

    /*component.margin=function(_){
        if(!arguments.length) return margin;
        margin=_;
        return component;
    };*/

    component.dispatch = dispatch;

    var svg = null;

    var two_day_bounds = [];
    var beselected = [];
    var output = [];
    var All_day_cluster=[];
    var Gly=[],
        Rad=[],
        Trp=[];

    //var lasso=d3.lasso(),
    // var ncolor = d3.scale.linear().range([d3.rgb(217, 83, 79).hsl(), d3.rgb(92, 184, 92).hsl()]).domain([0, 1]),
        // nsize = d3.scale.linear().range([5, 30]).domain([0, 1]);

    component.select = function(d) {
        if (d.flag) {
            select_cluster(d.cid);
        } else {
            delete_cluster(d.cid);
        }
        component.layout().update();
    };

    component.region_select = function(d) {
        var cor = regions[d.id].coordinates;
        var x = (cor[0][0] + cor[2][0]) / 2.0,
            y = (cor[0][1] + cor[1][1]) / 2.0;

        //component.flyTo([-73.985130, 40.758896]);
        /*for(var i=0;i<component.zoom()-7;i++){
            component.zoomOut();
        }
        for(var i=0;i<7-component.zoom();i++){
            component.zoomIn();
        }*/
        component.flyTo([x, y], 13.1);
        /*for(var i=0;i<3;i++){
            component.zoomIn();
        }*/
    };

    component.shade = function(c1, c2, c3) {
        last = c1;
        next = c2;
        rate = c3;
        component.layout().update();
    };

    component.focus_NY = function() {
        if(dataname=='newyork'){
            map.flyTo({ center: [-73.985130, 40.758896], speed: 1, zoom: 9, curve: 1 });
        }
        // map.flyTo({ center: [-73.985130, 40.758896], speed: 1, zoom: 9, curve: 1 });
        else if(dataname='manhattan'){
            map.flyTo({ center: [-73.96, 40.79], speed: 1, zoom: 9.5, curve: 1 });
        }
        
    };

    component.select_day = function(d) {
        day = d.day_id;
        beselected = [];
        //component.layout().update();
    };

    function select_cluster(option) {
        beselected.push(option);
    };

    function delete_cluster(option) {
        var find = 0;
        for (var i = 0; i < beselected.length; i++) {
            if (beselected[i] == option) {
                find = i;
                break;
            }
        }
        beselected.splice(find, 1);
    };


    var color_time=[];
    component.layout = function() {

        if (!regions) {
            return component;
        }

        for (var i = 0; i < regions.features.length; i++) {

            var coords = regions.features[i].geometry.coordinates[0];
            regions.features[i].id = i;
            regions.features[i].xy = [];
            
            // console.log(coords);
            for (var j = 0; j < coords.length; j++) {
                
                // console.log(coords[j][0]);
                var LngLat = new mapboxgl.LngLat(coords[j][0], coords[j][1]),
                    pt = map.project(LngLat);
                // console.log(pt);
                regions.features[i].xy.push([Math.round(pt.x * 10) / 10, Math.round(pt.y * 10) / 10]);

            }
        }

        return component;
    };

    component.render = function() {
        if (!container || !regions) {
            return component;
        }
        
        var c = map.getCanvasContainer();
        svg = d3.select(c)
            .append("svg")
            .attr("version", 1.1)
            .attr("xmlns", "http://www.w3.org/2000/svg")
            .attr("id", 'm' + container)
            .attr("width", $("#mainview").width())
            .attr("height", $("#mainview").height())
            .attr("class", "svg_map");

        // var rect = svg.append("rect")
        //     .attr("class", "backrect")
        //     .attr("width", $("#mainview").width())
        //     .attr("height", $("#mainview").height())
        //     .style("fill-opacity", 0);

        var canvas = svg.append("g")
            .attr("class", "canvas");

        return component.update();
    };

    component.update = function() {

        if (!svg) return;

        // $('.region path').tipsy("hide");

        //console.log(output);
        
        // console.log(max, min);


        var canvas = svg.select(".canvas");

        canvas.selectAll(".region").remove();
        
        var vregions = canvas.selectAll(".region").data(regions.features);

        vregions.exit().remove();

        var g1 = vregions.enter().append("g")
            .attr("class", "region")
            .attr("id",function(d){return d.id;});

        g1.append("path");

        canvas.selectAll(".region path")
            .attr("id",function(d){return "r"+d.id;})
            .attr("d", function(d) {
                return "M" + d.xy.join("L");
            })
            //              .style("stroke", function(d){return vis.region(d.cid);});
            .style("stroke", function(d) {
                return 'grey';
            })
            .style("stroke-opacity", .4)
            .style("stroke-width", 0.5)
            //.style("fill", function(d){return c20(d.cid);})
            .style("fill", function(d, i) {

                if (d.properties.totalCrashes) {
                    var ratio = (d.properties.totalCrashes - min) / (max - min);
                    var num = Math.round(ratio * 10);
                    // console.log(num);
                    // return colorbrewer.RdBu[11][10 - num];
                    // return color(1-num/10);
                    if(d.ratio) {
                        return d3.interpolateRdBu(1 - d.ratio);
                    } else {
                        return d3.interpolateRdBu(1 - ratio);
                    }
                    
                } else {
                    return "lightgrey";
                }
                
            })
            .style("fill-opacity", function(d){
                // return setfilter;
                if (d.properties.totalCrashes) {
                    return 1;
                } else {
                    return 0;
                }
            })
            .on("click",function(d){
                if (hover) {
                    d.click++;

                    // Add a text
                    if(d.click == 1) {
                        content = "Anomaly Found";
                        console.log(svg.select("#r" + d.id));
                        // svg.select("#r" + d.id).classed("once", true);
                        // svg.select("#r" + d.id).classed("selected", false);
                        svg.select("#r" + d.id).style("stroke", "red")
                                               .style("stroke-width", 1);

                    } else if(d.click == 2) {
                        content = "No Anomaly";
                        // svg.select("#r" + d.id).classed("once", false);
                        // svg.select("#r" + d.id).classed("selected", true);
                        svg.select("#r" + d.id).style("stroke", "black")
                                                .style("stroke-width", 1);

                    } else if(d.click == 3) {
                        content = "Operation Cancel";
                        // svg.select("#r" + d.id).classed("selected", false);
                        // svg.select("#r" + d.id).classed("once", false);
                        // container.select("#n" + d.id).classed("highlighted", false);
                        svg.select("#r" + d.id).style("stroke", "grey")
                                                .style("stroke-width", 1);

                    }

                    var clicktext = svg.append("text")
                        .attr("class", "click")
                        .attr("transform", "translate(" + size[0] + ", " + size[1] / 2 + ")")
                        .attr("dy", "1em")
                        .text(content)
                        .transition()
                        .duration(500)
                        .style("opacity", 0)
                        .remove();
                    // console.log(clicktext);    

                    if (d.click % 3 == 0) {
                        
                        remove(seleGrids["2"], d);
                        remove(seleGrids["1"], d);

                        remove(selection["1"], d);
                        remove(selection["2"], d);

                        d.click = 0
                    } else {
                        dispatch.select(d);
                    }
                }         
 
            })
            .on('contextmenu',function(d){
                dispatch.contextmenu(d, selection);

                // reset the selection of grids
                selection = {"1" : [], "2" : []};
            })
            // .on("dblclick", function(d) { dispatch.select(d); })
            .on("mouseover", function(d) { dispatch.mouseover(d); })
            .on("mouseout", function(d) { 
                dispatch.mouseout(d); 
                d.click = 0;
            });

        //lasso.items(svg.selectAll("circle"));
        component.border();

        return component;
    };

    component.border = function() {
        seleGrids["1"].forEach(function(d) {
            // container.select("#n" + d.id).classed("once", true);
            svg.select("#r" + d.id).style("stroke", "red")
            .style("stroke-width", 1);
        });
        seleGrids["2"].forEach(function(d) {
            // container.select("#n" + d.id).classed("selected", true);
            svg.select("#r" + d.id).style("stroke", "black")
            .style("stroke-width", 1);
        });
    };

    component.select = function(d) {

        remove(seleGrids["2"], d);
        remove(seleGrids["1"], d);

        remove(selection["1"], d);
        remove(selection["2"], d);

        d.selected = d.click;

        seleGrids[d.click].push(d);
        selection[d.click].push(d);

        console.log(seleGrids);
    };

    function updatemap() {
        component.layout().update();
    };

    function sum_up(a){
        var result=0;
        for(var i=0;i<a.length;i++){
            result+=a[i];
        }
        return result;
    }



    component.delete_all_cluster = function() {
        beselected = [];
        component.update();
    };


    component.highlight=function(d, flag){
        if(flag){
            // d3.select("#mainview").select("#r" + d.id).style("fill-opacity", 0.9);
            d3.select("#mainview")
              .select("#r" + d.id)
              .style("stroke-width", 2)
              .style("stroke", "black");
        } else {
            // d3.select("#mainview").select("#r" + d.id).style("fill-opacity", 0.5);
            d3.select("#mainview")
              .select("#r" + d.id)
              .style("stroke-width", 0.5)
              .style("stroke", "grey");
        }
        
        return component;
    }

    component.flyTo = function(lnglat, degree) {
        map.flyTo({ center: lnglat, speed: 1.6, zoom: degree, curve: 2 });
    };

    component.easeTo = function(option) {
        map.easeTo(option);
    };

    component.jumpTo = function(lnglat, degree) {
        map.jumpTo({ center: lnglat, zoom: degree });
    }

    component.rotateTo = function(degree) {
        map.rotateTo(degree);
    };

    component.panTo = function(lnglat) {
        map.panTo(lnglat);
    };

    component.zoomIn = function() {
        map.zoomIn();
    };

    component.zoomOut = function() {
        map.zoomOut();
    };

    component.restNorth = function() {
        map.resetNorth();
    };

    component.SVMUpdate = function(pValues) {

        pValues.forEach(function(element, i) {
            // statements
            regions.features[element.id].ratio = element.color;
        });
        return component.update();
    };

    component.BayesUpdate = function(d) {
        if(d.selected == 1){
            regions.features.forEach(function(a) {
                p = d.ratio;
                a.ratio = a.ratio * d.ratio;
            });  
            d.ratio = Math.min((1+d.q/2)*p, 1)
        }
        if(d.selected == 2){
            p = d.ratio;
            q = (d.q - 0.6) * 2.5;
            regions.features.forEach(function(a) {
                a.ratio = a.ratio / (1 - p * (1 - q));
                //a.p = Math.min(a.p, Math.random()+.5) 
            });
            d.ratio = p * q / (1 - p * (1 - q));
        }

        return component.update();
    };

    function remove(array, d) {
        if(array.indexOf(d) != -1) {
            array.splice(array.indexOf(d), 1);
        }
    };

    return component;
};