vis.radarview = function() {

    var radarview = {},
        container = null,
        nodes = [],
        q = 0;
        glyph = null,
        size = [960, 800],
        margin = { left: 10, top: 10, right: 10, bottom: 10 },
        dispatch = d3.dispatch("select", "mouseover", "mouseout", "click", "option");

    radarview.container = function(_) {
        if (!arguments.length) return container;
        container = _;
        return radarview;
    };

    radarview.nodes = function(_) {
        if (!arguments.length) return nodes;
        nodes = _.dots;
        q = _.q;
        return radarview;
    };

    radarview.size = function(_) {
        if (!arguments.length) return size;
        size = _;
        return radarview;
    };

    radarview.margin = function(_) {
        if (!arguments.length) return margin;
        margin = _;
        return radarview;
    };

    radarview.glyph = function(_) {
        if (!arguments.length) return glyph;
        glyph = _;
        return radarview;
    };

    radarview.dispatch = dispatch;

    ///////////////////////////////////////////////////
    // Private Parameters

    var trans = [0, 0],
        scale = 1,
        zoom = d3.behavior.zoom().on("zoom", function() {
            scale = d3.event.scale;
            trans = d3.event.translate;
            // container
            //     .select(".canvas")
            //     .attr("transform", "translate(" + (margin.left + trans[0]) + "," + (margin.top + trans[1]) + ") scale(" + scale + ")")
        });
    var gridsize = 120;

    var colorScale = (isAnomaly) => { return isAnomaly ? '#3182bd' : '#9ecae1' };
    ///////////////////////////////////////////////////
    // Public Function
    radarview.clear = function() {

        if (!container) {
            return;
        }

        container.selectAll(".node").remove();

        return radarview;
    };

    radarview.layout = function() {

        if (!nodes) {
            return radarview;
        }
        console.log(nodes);
        var rows = Math.floor(Math.sqrt(nodes.length));
        var cols = Math.ceil(nodes.length / rows);
        if(cols * rows < nodes.length) {
            cols += 1;
        }
        if(cols >= (rows + 2)) {
            rows += 1;
            cols -= 1;
        }

        if(!(parseInt(rows) == rows)) {
            // cols = Math.ceil(cols + 1);
            // rows = Math.floor(rows);
            cols = Math.floor(cols + 1);
            rows = nodes.length / cols;

            // rows = Math.floor(rows + 1);
            // cols = nodes.length / rows;
            console.log(rows, cols);
        }
        
        var gridsize_x = size[0] / rows;
        var gridsize_y = size[1] /cols;

        // var options = {};
        num = Math.max(rows, cols);
        var gridsize_y = size[1] / rows;
        var gridsize_x = size[0] / cols;
        // options.h = gridsize - 30;
        // options.w = gridsize - 30;
        // dispatch.option(options);

        var ss_x = cols * gridsize;
        var ss_y = rows * gridsize;

        var sx = (size[0] - ss_x) / 2.0 + 60;
        var sy = (size[1] - ss_y) / 2.0 + 50;
        console.log(sx, sy)

        for(var i = 0; i < rows; ++i) {
            for(var j = 0; j < cols; ++j) {
                var idx = i * cols + j;

                console.log(idx)
                if(idx >= nodes.length) {
                    break;
                }
                
                nodes[idx].px = sx + j * gridsize;
                nodes[idx].py = sy + i * gridsize;
                nodes[idx].w = gridsize;
                nodes[idx].h = gridsize;
            }
        }

        for (var i = 0; i < nodes.length; ++i) {

            function metric(nodes, i) {
                for (var j = 0; j < i; ++j) {
                    if(Math.sqrt((nodes[i].px - nodes[j].px) * (nodes[i].px - nodes[j].px) + (nodes[i].py - nodes[j].py) * (nodes[i].py - nodes[j].py)) < 100) {
                        return true;
                    }
                }
                return false;
            }

            do {
                nodes[i].px = Math.random() * (size[0] - 100) + 50;
                nodes[i].py = Math.random() * (size[1] - 100) + 50;
                // nodes[i].col = nodes[i].color;
                nodes[i].w = gridsize;
                nodes[i].h = gridsize;
                nodes[i].r = 15;
            } while (metric(nodes, i))
            
        }
        
        return radarview;
    };

    radarview.render = function() {

        if (!container) {
            return;
        }

        container
            .attr("width", size[0])
            .attr("height", size[1])
            // .attr("transform", "translate(0, " + (-4) + ")");

        container.selectAll(".canvas, .backrect, defs").remove();

        var color = d3.interpolate('#fff', '#9ecae1');
        // initiate a zooming pannel
        // var rectangle = container.append("rect")
        //     .attr("class", "backrect")
        //     .attr("x", 0)
        //     .attr("y", 0)
        //     .attr("id", "radarview")
        //     .attr("width", size[0])
        //     .attr("height", size[1])
        //     .attr("fill", 'white')
        //     .style("stroke", "lightgrey")
        //     .style("stroke-width", "4px")

            // Method 3: add the background color
            // .attr("fill", function() {
            //     console.log(q);
            //     // Method 3: add the background color
            //     return color(q);
            // });

        // container.append("rect")
        //     .attr("class", "backrect")
        //     .attr("x", 0)
        //     .attr("y", 0)
        //     .attr("width", 0.5 * size[0])
        //     .attr("height", 0.5 * size[1])
        //     .attr("transform", "translate(" + ( 0.5 * size[0]) + "," + ( 0.5 * size[1]) + ")")
        //     .attr("fill", 'white')
        //     .style("stroke", "lightgrey")
        //     .style("stroke-width", "4px");

        container.append("svg:defs")
            .append("filter")
            .attr("id", "blur")
            .append("feGaussianBlur")
            // .attr("stdDeviation", q * 10);

        //     .on('dblclick', function(d) {
        //         trans = [0, 0];
        //         scale = 1;
        //         zoom.scale(scale).translate(trans);
        //         container.select(".canvas")
        //             .attr("transform", "translate(" + (margin.left + trans[0]) + "," + (margin.top + trans[1]) + ") scale(" + scale + ")")
        //     })
        //     .call(zoom).on("dblclick.zoom", null);

        // create the rendering pannel  
        // container.append("g")
        //     .attr("class", "canvas")
        //     .attr("transform", "translate(" + (margin.left + trans[0]) + "," + (margin.top + trans[1]) + ") scale(" + scale + ")");

        return radarview.update();
    };

    radarview.update = function() {

        if(!nodes) {
            return;
        }

        // var canvas = container.select(".canvas");
        var vnodes = container.selectAll(".node")
            .data(nodes);


        // remove old nodes
        vnodes.exit().remove();

        // update of all existing nodes
        container.selectAll(".node circle")
            .attr("cx", function(d) { return d.px; })
            .attr("cy", function(d) { return d.py; })
            .attr("r", function(d) { return d.r; })

        // append new nodes
        // vnodes.enter().append("g")
        //     .attr("class", "node")
        //     .append("circle")
        //     .attr("cx", function(d) { return d.px; })
        //     .attr("cy", function(d) { return d.py; })
        //     .attr("transform", "translate(0, " + (-5) + ")")
        //     .attr("r", function(d) { return d.r; })
        //     .style("fill", function(d) { return colorScale(d.isAnomaly); })
        //     .style('opacity', 0.6)
        //     .on("mouseover", dispatch.mouseover)
        //     .on("mouseout", dispatch.mouseout)
        //     .on("click", function(d) {})

            // Method 1: add the filter effect
            // .attr("filter", "url(#blur)")

            // Method 2: change the density of the dots
            // .attr("cx", function(d) { 
            //     var ratio = 1 - 2/3 * q;
            //     d.px = ratio * size[0] * d.x;
            //     return d.px + size[0] * (1 - ratio)/2; 
            // })
            // .attr("cy", function(d) { 
            //     var ratio = 1 - 2/3 * q;
            //     d.py = ratio * size[0] * d.y;
            //     return d.py + size[1] * (1 - ratio)/2; 
            // })

        var nnodes = vnodes.enter()
            .append("g")
            .attr("class", "node")
            .attr("transform", function(d) {
                return "translate(" + d.px + "," + d.py + ")";
            });

        if(glyph) {
            vnodes.call(glyph);
        }

        // vnodes.on("click", function(d) {
        //         dispatch.select(d);
        //     })
        //     .on("mouseover", function(d) {
        //         dispatch.mouseover(d);
        //     })
        //     .on("mouseout", function(d) {
        //         dispatch.mouseout(d);
        //     });

        return radarview;
    };

    ///////////////////////////////////////////////////
    // Private Functions

    function private_function1() {

    };

    function private_function2() {

    };

    function private_function3() {

    };

    return radarview;
};